import es
import langlib
import playerlib
import popuplib

lang_dir = "cstrike/addons/eventscripts/soccer_mod_2010/language/"

texts = langlib.Strings(lang_dir + "admin/settings/popup_admin_settings_referee.ini")
text_referee = langlib.Strings(lang_dir + "cap/popup_admin_referee_warn.ini")
messages = langlib.Strings(lang_dir + "admin/settings/messages_settings_referee.ini")

popup = popuplib.create("sm_popup_admin_settings_referee")

# ******************** Load ********************
def load():
	for i in range(1, 8):
		es.set("sm_referee_warning_%s" % (i), es.keygetvalue("soccer_mod_settings", "referee", "warning_%s" % (i)))

	create_popup()

	es.addons.registerSayFilter(filter)

# ******************** Create popup ********************
def create_popup():
	common = langlib.Strings(lang_dir + "popup_common.ini")

	popup.addline("SOCCER MOD %s" % (texts("title")))
	popup.addline(" ")

	for i in range(1, 8):
		popup.addline("->%s. %s #%s: %s" % (i, texts("warning"), i, es.ServerVar("sm_referee_warning_%s" % (i))))
		popup.select(i, change_setting)

	popup.addline(" ")
	popup.addline("->9. %s" % (common("back")))
	popup.addline(" ")
	popup.addline("->0. %s" % (common("close")))

	popup.submenu(8, "sm_popup_admin_settings_referee")
	popup.submenu(9, "sm_popup_admin_settings")

# ******************** Popup choice ********************
def change_setting(userid, choice, popupid):
	tokens = {}
	player = playerlib.getPlayer(userid)

	if es.exists("key", "sm_keygroup_set", player.steamid) == 0:
		es.keycreate("sm_keygroup_set", player.steamid)

	es.keysetvalue("sm_keygroup_set", player.steamid, "setting_type", "settings_referee_warning_%s" % (choice))

	es.tell(userid, "#green", messages("type_warning", tokens, player.get("lang")))

# ******************** Events ********************
def filter(userid, text, teamonly):
	tokens = {}
	player = playerlib.getPlayer(userid)

	exists = es.exists("key", "sm_keygroup_set", player.steamid)
	if exists == 1:
		text = text.strip('"')

		type = es.keygetvalue("sm_keygroup_set", player.steamid, "setting_type")
		type_split = type.split("_")
		if type_split[0] == "settings" and type_split[1] == "referee" and type_split[2] == "warning":
			if text != "!cancel":
				number = int(type_split[3])

				es.set("sm_referee_warning_%s" % (number), text)

				tokens["weapon"] = text
				tokens["name"] = player.name
				tokens["number"] = number

				popup.modline(number + 2, "->%s. %s #%s: %s" % (number, texts("warning"), number, text))

				popuplib.find("sm_popup_admin_referee_warn").modline(number + 2, "->%s. %s" % (number, text_referee("warning")))

				lang_msg("set_warning", tokens)

				es.keysetvalue("soccer_mod_settings", "referee", "warning_%s" % (number), text)
				es.keygroupsave("soccer_mod_settings", "soccer_mod")

			es.keydelete("sm_keygroup_set", player.steamid)

			popuplib.send("sm_popup_admin_settings_referee", userid)

			return (0, None, 0)
		else:
			return (userid, text, teamonly)
	else:
		return (userid, text, teamonly)

# ******************** Functions ********************
def lang_msg(text, tokens):
	for player in playerlib.getPlayerList("#human"):
		es.tell(player.userid, "#green", messages(text, tokens, player.get("lang")))

# ******************** Unload ********************
def unload():
	popuplib.delete("sm_popup_admin_settings_referee")

	es.addons.unregisterSayFilter(filter)