﻿import cmdlib
import es
import os

modules = ["cap", "match", "referee", "shout", "skins", "sprint", "training", "vote"]

# ******************** Load ********************
def load():
	files = ["downloads.cfg", "es_soccer_mod_admins_db.txt", "es_soccer_mod_maps_db.txt", "es_soccer_mod_settings_db.txt", "es_soccer_mod_skins_db.txt", "ranking.db", "soccer_mod.cfg"]
	clear_dir("cstrike/cfg/soccer_mod/", files)

	files = ["cap.cfg", "match.cfg", "referee.cfg", "shout.cfg", "skins.cfg", "sprint.cfg", "training.cfg", "vote.cfg"]
	clear_dir("cstrike/cfg/soccer_mod/modules/", files)

	es.set("sm_downloads_on", 1)
	es.set("sm_downloads_auto_on", 1)

	cmdlib.registerServerCommand("soccer_mod_downloads_on", downloads, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_automatic_downloads_on", automatic_downloads, "Server Command")

	es.set("sm_command_admin", "!menu")
	es.set("sm_command_info", "!info")

	cmdlib.registerServerCommand("soccer_mod_command_admin", command_admin, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_command_info", command_info, "Server Command")

	es.set("sm_module_cap_on", 1)
	es.set("sm_module_match_on", 1)
	es.set("sm_module_player_on", 1)
	es.set("sm_module_referee_on", 1)
	es.set("sm_module_shout_on", 1)
	es.set("sm_module_skins_on", 1)
	es.set("sm_module_sprint_on", 1)
	es.set("sm_module_training_on", 1)
	es.set("sm_module_vote_on", 1)

	cmdlib.registerServerCommand("soccer_mod_module_cap_on", module_cap, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_match_on", module_match, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_player_on", module_player, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_referee_on", module_referee, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_shout_on", module_shout, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_skins_on", module_skins, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_sprint_on", module_sprint, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_training_on", module_training, "Server Command")
	cmdlib.registerServerCommand("soccer_mod_module_vote_on", module_vote, "Server Command")

	es.server.cmd("exec soccer_mod/soccer_mod.cfg")

	reg("sm_command_admin", "soccer_mod_2010/admin/cmd_admin")
	reg("sm_command_info", "soccer_mod_2010/info/cmd_info")

	for item in modules:
		if es.ServerVar("sm_module_%s_on" % (item)) == 1:
			es.load("soccer_mod_2010/cfg/%s" % (item))

# ******************** Events ********************
def es_map_start(event_var):
	if es.exists("key", "soccer_mod_maps", event_var["mapname"]) == 1:
		es.set("soccer_mod_allowed", 1)

		if int(es.ServerVar("sm_downloads_on")) == 1:
			es.doblock("soccer_mod_2010/downloads/refresh_downloads")
			es.server.cmd("exec soccer_mod/downloads.cfg")
	else:
		es.set("soccer_mod_allowed", 0)

# ******************** Commands ********************
def downloads(args):
	on_off("sm_downloads_on", args[0])

def automatic_downloads(args):
	on_off("sm_downloads_auto_on", args[0])

def command_admin(args):
	es.set("sm_command_admin", args[0])

def command_info(args):
	es.set("sm_command_info", args[0])

def module_cap(args):
	on_off("sm_module_cap_on", args[0])

def module_match(args):
	on_off("sm_module_match_on", args[0])

def module_player(args):
	on_off("sm_module_player_on", args[0])

def module_referee(args):
	on_off("sm_module_referee_on", args[0])

def module_shout(args):
	on_off("sm_module_shout_on", args[0])

def module_skins(args):
	on_off("sm_module_skins_on", args[0])

def module_sprint(args):
	on_off("sm_module_sprint_on", args[0])

def module_training(args):
	on_off("sm_module_training_on", args[0])

def module_vote(args):
	on_off("sm_module_vote_on", args[0])

# ******************** Functions ********************
def clear_dir(path, files):
	for item in os.listdir(path):
		if item not in files:
			try:
				os.remove(path + str(item))
			except OSError:
				error = 1

def reg(name, block):
	cmd = es.ServerVar(name)

	if es.exists("saycommand", cmd) == 0:
		es.regsaycmd(cmd, block)

	if es.exists("clientcommand", cmd) == 0:
		es.regclientcmd(cmd, block)

def unreg(name):
	cmd = es.ServerVar(name)

	if es.exists("saycommand", cmd) == 1:
		es.unregsaycmd(cmd)

	if es.exists("clientcommand", cmd) == 1:
		es.unregclientcmd(cmd)

def on_off(name, value):
	try:
		if int(value) == 1:
			es.set(name, 1)
		else:
			es.set(name, 0)
	except ValueError:
		es.set(name, 0)

# ******************** Unload ********************
def unload():
	cmdlib.unregisterServerCommand("soccer_mod_downloads_on")
	cmdlib.unregisterServerCommand("soccer_mod_automatic_downloads_on")

	cmdlib.unregisterServerCommand("soccer_mod_command_admin")
	cmdlib.unregisterServerCommand("soccer_mod_command_info")

	cmdlib.unregisterServerCommand("soccer_mod_module_cap_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_match_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_player_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_referee_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_shout_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_skins_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_sprint_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_training_on")
	cmdlib.unregisterServerCommand("soccer_mod_module_vote_on")

	unreg("sm_command_admin")
	unreg("sm_command_info")

	for item in modules:
		if es.ServerVar("sm_module_%s_on" % (item)) == 1:
			es.unload("soccer_mod_2010/cfg/%s" % (item))